/*
 * 4.4.1. Alocare dinamica. Alegerea dimensiunii blocului de alocat.
 */


#include <iostream.h>

extern unsigned _stklen = 32 * 1024;
static int nivel;
static int raport;

void alocareDinamica( unsigned n ) {
  ++nivel;
  char *ptr = new char[ n ];
  if ( ptr )
    alocareDinamica( n );

  // memoria libera este epuizata
  delete ptr;
  if ( !raport++ )
    cout << "\nMemoria libera a fost epuizata. "
      << "S-au alocat "
      << (long)nivel * n * sizeof( char ) / 1024 << 'K'
      << ".\nNumarul de apeluri " << nivel
      << "; la fiecare apel s-au alocat "
      << n * sizeof( char ) << " octeti.\n";
}


main( ) {
  for ( unsigned i = 1024; i > 32; i /= 2 ) {
    nivel = 1; raport = 0;
    alocareDinamica( 64 * i - 1 );
  }

  return 1;
}
