/*
 * 4.4.4. Clasa parametrica coada<T>. Fisierul header.
 */

#ifndef __COADA_H
#define __COADA_H

#include <iostream.h>
#include "tablou.h"

template <class T>
class coada: private tablou<T> {
public:
  coada( int d ): tablou<T>( d )
    { head = tail = 0; }

  ins_q( const T& );
  del_q(       T& );

private:
  int head; // indicele ultimei locatii ocupate
  int tail; // indicele locatiei predecesoare primei
            // locatii ocupate
};

template <class T>
coada<T>::ins_q( const T& x ) {
  int h = ( head + 1 ) % d;
  if ( h == tail )   return 0;
  a[ head = h ] = x; return 1;
}

template <class T>
coada<T>::del_q( T& x ) {
  if ( head == tail ) return 0;
  tail = ( tail + 1 ) % d;
  x = a[ tail ];      return 1;
}

#endif
