/*
 * 2.2.1. Ilustrarea unor diferente dintre limbajele C si C++.
 */

#include <stdio.h>

/* intregul 3 va fi convertit la float */
float maxim( float, float );
float x = maxim( 3, 2.5 );


/* functie invocata prin inlocuirea secventei
   de apel cu corpul functiei */
inline float maxim( float x, float y ) {
  putchar( 'r' ); return x > y? x: y;
}


/* supraincarcarea functiei float maxim( float, float ) */
inline int maxim( int x, int y ) {
  putchar( 'i' ); return x > y? x: y;
}


/* constanta simbolica */
#define DIM 5

/* o functie de test */
void f( ) {
  int buf[ DIM ];

  for ( int i = 0; i < DIM; )
    buf[ i++ ] = maxim( i, DIM - i );
  while ( --i )
    printf( "%3d ", buf[ i ] );
}


/* parametrii de tip referinta */
void swap( float& a, float& b ) {
  float tmp = a; a = b; b = tmp;
}


/* structura "punct" */
struct punct {
  float x;     /* coordonatele unui */
  float y;     /* punct din plan    */
};


// p este inlocuit cu simetricul lui
// fata de cea de a doua bisectoare
void sim2( struct punct& p ) {
  swap( p.x, p.y ); // p.x si p.y se transmit prin
                    // referinta si nu prin valoare
  p.x = -p.x; p.y = -p.y;
}

// tiparirea coordonatelor puctului p
void print( const struct punct& p ) {
  // compilatorul interzice orice tentativa
  // de a modifica variabila p
  printf( "(%4.1f, %4.1f) ", p.x, p.y );
}

// cea de a doua functie de test
void g( ) {
  const int dim = 5;
  struct punct buf[ dim ];

  for ( int i = 0; i < dim; i++ ) {
    buf[ i ].x = i;
    buf[ i ].y = dim / 2. - i;

    sim2(  buf[ i ] );
    print( buf[ i ] );
  }
}


// funcia main()
int main( ) {
  puts( "\n main." );

  puts( "\n  f( )" ); f( );
  puts( "\n  g( )" ); g( );

  puts( "\n ---\n" );
  return 0;
}

