/*
 * 2.4.5. Program pentru calculul combinarilor.
 *             Se utilizeaza formula recursiva
 *               data de triunghiul lui Pascal.
 */

#include <iostream.h>

const int N = 16, M = 17;
int r[N][M];  // contorizeaza numarul de apeluri ale
              //   functiei C( int, int ) separat,
              //   pentru toate valorile argumentelor
long tr;      // numarul total de apeluri ale
              //   functiei C( int, int )

int C( int n, int m ) {
  r[n][m]++; tr++;
  return m == 0 || m == n?
    1: C( n - 1, m - 1 ) + C( n - 1, m );
}

void main( ) {
  int n, m;
  for ( n = 0; n < N; n++ )
    for ( m = 0; m < M; m++ ) r[n][m] = 0;
  tr = 0;

  cout << "\nCombinari de (maxim " << N << ") ... ";
  cin >> n;
  cout << "             luate cate ... ";
  cin >> m;
  cout << "sunt " << C( n, m ) << '\n';

  cout << "\n\nC( int, int ) a fost invocata de "
       << tr << " ori astfel:\n";
  for ( int i = 1; i <= n; i++, cout << '\n' )
    for ( int j = 0; j <= i; j++ ) {
      cout.width( 4 );
      cout << r[i][j] << ' ';
    }
}
