/*
 * 6.4. Implementarea arborilor de interclasare.
 */

#include <iostream.h>
#include "tablou.h"
#include "heap.h"
#include "vp.h"


class nod {
public:
  int lu; // lungimea
  int st; // fiul stang
  int dr; // fiul drept
};

inline ostream& operator <<( ostream& os, nod& nd ) {
  os << " <" << nd.st << "< "
     << nd.lu
     << " >" << nd.dr << "> ";
  return os;
}

tablou<nod> interopt( const tablou<int>& Q ) {
  int n = Q.size( );

  tablou<nod> A( 2 * n - 1 ); // arborele de interclasare
  heap  <vp>  H( 2 * n - 1 );

  for ( int i = 0; i < n; i++ ) {
    H.insert( vp(i, Q[i]) );
    A[i].lu = Q[i]; A[i].st = A[i].dr = -1;
  }
  for ( i = n; i < 2 * n - 1; i++ ) {
    vp s; H.delete_max( s );
    vp r; H.delete_max( r );
    A[i].st = s; A[i].dr = r;
    A[i].lu = (float)s + (float)r;
    H.insert( vp(i, A[i].lu) );
  }
  return A;
}


main( ) {
  tablou<int> l;
  cout << "Siruri: "; cin >> l;
  cout << "Arborele de interclasare: ";
  cout << interopt( l ) << '\n';
  return 1;
}
