/*
 * 2.3.2. Clasa intErval. Declaratii.
 *
 * Clasa a fost completeta pe baza observatiilor din Sectiunea 4.2.2:
 *  - operatorul int este declarat const
 *  - s-a adaugat operatorul de atribuire pentru obiecte intErval
 *    (in lipsa lui atribuirile fiind rezolvate prin conversia la int).
 */

#ifndef __INTeRVAL_H
#define __INTeRVAL_H

#include <iostream.h>

class intErval {
public:
  intErval( int = 1, int = 0 );
  ~intErval( ) { }

  int operator =( int i ) { return v = verDom( i ); }
  operator int( ) const { return v; }

  intErval& operator =( const intErval& );

private:
  int verDom( int );

  int min, max;
  int v;
};

istream& operator >>( istream&, intErval& );

#endif
