/*
 * 6.7. Clasa set. Definitiile functiilor membre.
 */

#include "set.h"

set::set( int n ): set( n ) {
  set.vOn( );
  for ( int i = 0; i < n; i++ )
    set[ i ] = -1;
}

void set::merge3( int a, int b ) {
  // sunt a si b etichete de multimi?
  if ( set[ a ] >= 0 ) a = find3( a );
  if ( set[ b ] >= 0 ) b = find3( b );

  // sunt multimile a si b diferite?
  if ( a == b ) return;

  // reuniunea propriu-zisa
  if ( set[ a ] == set[ b ] ) set[ set[ b ] = a ]--;
  else if ( set[ a ] < set[ b ] )  set[ b ] = a;
       else                        set[ a ] = b;

  return;
}

int set::find3( int x ) {
  int r = x;
  while ( set[ r ] >= 0 )
    r = set[ r ];

  int i = x;
  while ( i != r )
    { int j = set[ i ]; set[ i ] = r; i = j; }

  return r;
}
