/*
 * 4.2.1. Clasa parametrica stiva<T>. Fisierul header.
 */

#ifndef __STIVA_H
#define __STIVA_H

#include <iostream.h>
#include "tablou.h"

template <class T>
class stiva: private tablou<T> {
public:
  stiva( int d ):  tablou<T>( d ) { s = -1; }

  push( const T& );
  pop (       T& );

private:
  int s;  // indicele ultimului element inserat
};

template <class T>
stiva<T>::push( const T& v ) {
  if ( s >= d - 1 ) return 0;
  a[ ++s ] = v;     return 1;
}

template <class T>
stiva<T>::pop( T& v ) {
  if ( s < 0 )  return 0;
  v = a[ s-- ]; return 1;
}

#endif
