/*
 * 10.2. Testarea clasei tablouVI<T>. RTTI.
 *
 */

#include <iostream.h>
#include "tablouVI.h"

template <class T>
void swap( tablou<T>& a, tablou<T>& b ) {
  if ( a.tip( ) != b.tip( ) )
    cerr << "\n\nswap -- tablouri de tipuri diferite.\n\n";
  else {
    tablou<T> tmp = a;
    a = b;
    b = tmp;
  }
}

// declaratii necesare pentru a evita
// referirea la sabloane - vezi Sectiunea 4.1.3
void swap( tablou<int>&, tablou<int>& );
ostream& operator <<( ostream&, tablou<int>& );

// fortarea generarii unor functii pentru GNU C++ 2.6.1
// inline void _( tablou<int>& x ) { cout << x; swap( x, x); }

main( ) {
  cout << "\nTablou (de intregi) initializat virtual."
       << "\nNumarul elementelor, valoarea implicita ... ";
  int n, v;
  cin >> n >> v;

  tablouVI<int> x6( n, v );

  cout << "\nIndicele, valoarea (prin indicele -1 se\n"
       << " modifica valoarea implicita) <EOF>:\n...";
  while( cin >> n >> v ) {
    if ( n == -1 ) x6 = v; else x6[ n ] = v;
    cout << "...";
  }
  cin.clear( );

  tablou<int> z = x6;

  cout << '\n' << x6 << '\n';
  cout << "\n\nUn tablou initializat cu tablouVI:\n  "
       << z << '\n';

  swap(  z, x6 );
  return 1;
}
